   '****************************************************************
   '*    Recipe file type                                      *
   '****************************************************************

    Type RecipeType
        RecNo            As String * 6
        RecDesc          As String * 30
        RecGroup         As String * 4
        RecRetail        As Integer
        Servings         As Integer
        UpdateFlag       As String * 1
        TargetProfit     As Single
        MaintenanceCode  As String * 1
        ShelfLifeDays    As Integer
    End Type

    Type RecipeDetType
        RecDetKey        As String * 21
          'Composed of
          'RecNo            As String * 6
          'IngKey           As String * 15     (Key1)
             'Composed of
             'SupplierNo       As String * 3
             'IngredientNo     As String * 12
        RecDetQty           As Double
    End Type

    Global RecipeRec As RecipeType
    Global RecipeSaveRec As RecipeType
    Global RecipeSt%
    Global RecipeKeyB$
    Global RecipePosBlk As PosBlk

    Global RecipeDetRec As RecipeDetType
    Global RecipeDetSaveRec As RecipeDetType
    Global RecipeDetSt%
    Global RecipeDetKeyB$
    Global RecipeDetPosBlk As PosBlk

'**************************************************************************
'*                     Begin Recipe Header Subroutines                    *
'**************************************************************************

'**************************************************************************
'*                     Begin Recipe Detail Subroutines                    *
'**************************************************************************

Sub CloseRecipeDetFile ()
    RecipeDetKeyBufLen% = 255
    RecipeDetBufLen% = Len(RecipeDetRec)
    KeyNum% = 0
    RecipeDetSt% = 0
    RecipeDetSt% = btrcall(BCLOSE, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub CloseRecipeFile ()
    RecipeKeyBufLen% = 255
    RecipeBufLen% = Len(RecipeRec)
    KeyNum% = 0
    RecipeSt% = 0
    RecipeSt% = btrcall(BCLOSE, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
End Sub

Sub DeleteRecipe ()
      RecipeKeyBufLen% = 255
      RecipeBufLen% = Len(RecipeRec)
      KeyNum% = 0
      RecipeSt% = 0
      RecipeSt% = btrcall(BDELETE, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
End Sub

Sub DeleteRecipeDet ()
      RecipeDetKeyBufLen% = 255
      RecipeDetBufLen% = Len(RecipeDetRec)
      KeyNum% = 0
      RecipeDetSt% = 0
      RecipeDetSt% = btrcall(BDELETE, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub FirstRecipe ()
  If Len(RecipeKeyB$) <> 6 Then
    RecipeKeyB$ = String$(6, " ")
  End If
  RecipeKeyBufLen% = 255
  RecipeBufLen% = Len(RecipeRec)
  KeyNum% = 0
  RecipeSt% = 0
  RecipeSt% = btrcall(BFIRST, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
End Sub

Sub FirstRecipeDet ()
  If Len(RecipeDetKeyB$) <> 21 Then
    RecipeDetKeyB$ = String$(21, " ")
  End If
  RecipeDetKeyBufLen% = 255
  RecipeDetBufLen% = Len(RecipeDetRec)
  KeyNum% = 0
  RecipeDetSt% = 0
  RecipeDetSt% = btrcall(BFIRST, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub FirstRecipeKey1 ()
  If Len(RecipeKeyB$) <> 10 Then
    RecipeKeyB$ = String$(10, " ")
  End If
  RecipeKeyBufLen% = 255
  RecipeBufLen% = Len(RecipeRec)
  KeyNum% = 1
  RecipeSt% = 0
  RecipeSt% = btrcall(BFIRST, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
End Sub

Sub GetGERecipeDet ()
  RecipeDetKeyB$ = RecipeDetRec.RecDetKey
  RecipeDetKeyBufLen% = 255
  RecipeDetBufLen% = Len(RecipeDetRec)
  KeyNum% = 0
  RecipeDetSt% = 0
  RecipeDetSt% = btrcall(BGETGE, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub MsgRecipeDetDuplicate ()
  Msg$ = "Ingredient is already in this recipe."
  T1% = MsgBox(Msg$, 0, "Note!")
End Sub

Sub MsgRecipeDetNotFound ()
  Msg$ = "Recipe Detail not found.  Status = " + Str$(RecipeDetSt%)
  T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgRecipeDetNotOpen ()
        Msg$ = "Recipe Detail file not opened."
        T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgRecipeNotFound ()
  Msg$ = "Recipe not found.  Status = " + Str$(RecipeSt%)
  T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgRecipeNotOpen ()
        Msg$ = "Recipe file not opened."
        T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgUnknownRecipeDetError ()
  Msg$ = "Recipe Detail file error.  Status = " + Str$(RecipeDetSt%)
  T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub MsgUnknownRecipeError ()
  Msg$ = "Recipe file error.  Status = " + Str$(RecipeSt%)
  T1% = MsgBox(Msg$, 0, "Warning!")
End Sub

Sub NextRecipe ()
  If Len(RecipeKeyB$) <> 6 Then
    RecipeKeyB$ = String$(6, " ")
  End If
  RecipeKeyBufLen% = 255
  RecipeBufLen% = Len(RecipeRec)
  KeyNum% = 0
  RecipeSt% = 0
  RecipeSt% = btrcall(BNEXT, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
End Sub

Sub NextRecipeDet ()
  If Len(RecipeDetKeyB$) <> 21 Then
    RecipeDetKeyB$ = String$(21, " ")
  End If
  RecipeDetKeyBufLen% = 255
  RecipeDetBufLen% = Len(RecipeDetRec)
  KeyNum% = 0
  RecipeDetSt% = 0
  RecipeDetSt% = btrcall(BNEXT, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub NextRecipeDetKey1 ()
  If Len(RecipeDetKeyB$) <> 15 Then
    RecipeDetKeyB$ = String$(15, " ")
  End If
  RecipeDetKeyBufLen% = 255
  RecipeDetBufLen% = Len(RecipeDetRec)
  KeyNum% = 1
  RecipeDetSt% = 0
  RecipeDetSt% = btrcall(BNEXT, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub NextRecipeKey1 ()
  If Len(RecipeKeyB$) <> 10 Then
    RecipeKeyB$ = String$(10, " ")
  End If
  RecipeKeyBufLen% = 255
  RecipeBufLen% = Len(RecipeRec)
  KeyNum% = 1
  RecipeSt% = 0
  RecipeSt% = btrcall(BNEXT, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
End Sub

Sub OpenRecipeDetFile ()
    RecipeDetKeyB$ = "recdfile.btr"
    RecipeDetKeyBufLen% = 255
    RecipeDetBufLen% = Len(RecipeDetRec)
    KeyNum% = 0
    RecipeDetSt% = 0
    RecipeDetSt% = btrcall(BOPEN, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
    If RecipeDetSt% <> 0 Then
      Msg$ = "RecipeDet file open failed. Status = " + Str$(RecipeDetSt%)
      T1% = MsgBox(Msg$, 0, "Warning!")
    End If
End Sub

Sub OpenRecipeFile ()
    RecipeKeyB$ = "rechfile.btr"
    RecipeKeyBufLen% = 255
    RecipeBufLen% = Len(RecipeRec)
    KeyNum% = 0
    RecipeSt% = 0
    RecipeSt% = btrcall(BOPEN, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
    If RecipeSt% <> 0 Then
      Msg$ = "Recipe file open failed. Status = " + Str$(RecipeSt%)
      T1% = MsgBox(Msg$, 0, "Warning!")
    End If
End Sub

Sub PreviousRecipe ()
  If Len(RecipeKeyB$) <> 6 Then
    RecipeKeyB$ = String$(6, " ")
  End If
  RecipeKeyBufLen% = 255
  RecipeBufLen% = Len(RecipeRec)
  KeyNum% = 0
  RecipeSt% = 0
  RecipeSt% = btrcall(BPREVIOUS, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
End Sub

Sub PreviousRecipeDet ()
  If Len(RecipeDetKeyB$) <> 21 Then
    RecipeDetKeyB$ = String$(21, " ")
  End If
  RecipeDetKeyBufLen% = 255
  RecipeDetBufLen% = Len(RecipeDetRec)
  KeyNum% = 0
  RecipeDetSt% = 0
  RecipeDetSt% = btrcall(BPREVIOUS, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub ReadRecipe ()
    RecipeKeyB$ = RecipeRec.RecNo
    RecipeKeyBufLen% = 255
    RecipeBufLen% = Len(RecipeRec)
    KeyNum% = 0
    RecipeSt% = 0
    RecipeSt% = btrcall(BEQUAL, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
End Sub

Sub ReadRecipeDet ()
    RecipeDetKeyB$ = RecipeDetRec.RecDetKey
    RecipeDetKeyBufLen% = 255
    RecipeDetBufLen% = Len(RecipeDetRec)
    KeyNum% = 0
    RecipeDetSt% = 0
    RecipeDetSt% = btrcall(BEQUAL, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub ReadRecipeDetKey1 ()
    RecipeDetKeyB$ = Mid$(RecipeDetRec.RecDetKey, 7, 15)
    RecipeDetKeyBufLen% = 255
    RecipeDetBufLen% = Len(RecipeDetRec)
    KeyNum% = 1
    RecipeDetSt% = 0
    RecipeDetSt% = btrcall(BEQUAL, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub UpdateRecipe ()
    RecipeKeyBufLen% = 255
    RecipeBufLen% = Len(RecipeRec)
    KeyNum% = 0
    RecipeSt% = 0
    RecipeSt% = btrcall(BUPDATE, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
End Sub

Sub UpdateRecipeDet ()
    RecipeDetKeyBufLen% = 255
    RecipeDetBufLen% = Len(RecipeDetRec)
    KeyNum% = 0
    RecipeDetSt% = 0
    RecipeDetSt% = btrcall(BUPDATE, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub UpdateRecipeDetKey1 ()
    RecipeDetKeyBufLen% = 255
    RecipeDetBufLen% = Len(RecipeDetRec)
    KeyNum% = 1
    RecipeDetSt% = 0
    RecipeDetSt% = btrcall(BUPDATE, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

Sub WriteRecipe ()
      RecipeKeyBufLen% = 255
      RecipeBufLen% = Len(RecipeRec)
      KeyNum% = 0
      RecipeSt% = 0
      RecipeSt% = btrcall(BINSERT, RecipePosBlk, RecipeRec, RecipeBufLen%, RecipeKeyB$, RecipeKeyBufLen%, KeyNum%)
End Sub

Sub WriteRecipeDet ()
      RecipeDetKeyBufLen% = 255
      RecipeDetBufLen% = Len(RecipeDetRec)
      KeyNum% = 0
      RecipeDetSt% = 0
      RecipeDetSt% = btrcall(BINSERT, RecipeDetPosBlk, RecipeDetRec, RecipeDetBufLen%, RecipeDetKeyB$, RecipeDetKeyBufLen%, KeyNum%)
End Sub

